
// TestGyroAccelDlg.cpp :  
//

#include "stdafx.h"
#include "TestGyroAccel.h"
#include "TestGyroAccelDlg.h"
#include "mm.h"

#include "ARS.h"
#include "GyroAccelDevice.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTestGyroAccelDlg ȭ 
CTestGyroAccelDlg::CTestGyroAccelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestGyroAccelDlg::IDD, pParent), _isRun(false)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	InitDevice();
}

CTestGyroAccelDlg::~CTestGyroAccelDlg()
{
	DeinitDevice();
}

void CTestGyroAccelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTestGyroAccelDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_RUN, &CTestGyroAccelDlg::OnBnClickedRun)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CTestGyroAccelDlg ޽ ó

BOOL CTestGyroAccelDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.
	InitializeGraph();

	CRect rcOgl;
	GetDlgItem(IDC_OPENGL_VIEW)->GetWindowRect(rcOgl);
	GetDlgItem(IDC_OPENGL_VIEW)->DestroyWindow();
	
	ScreenToClient(rcOgl);

	_modelWnd = new COglWndExt();
	_modelWnd->CreateEx(0, "#32770", "Robot View", WS_TABSTOP | WS_CHILD | WS_VISIBLE, rcOgl, this, IDC_OPENGL_VIEW);
	_modelWnd->_eyePos.x = 0.5;
	_modelWnd->_centerPos.z = 0.;
	_modelWnd->_angleHor = 60;
	_modelWnd->_angleVer = 20; 
	_modelWnd->ShowWindow(SW_SHOW);
	_modelWnd->SetFocus ();

	ConnectDevice();

	OnBnClickedRun();

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ. /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CTestGyroAccelDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮ

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CTestGyroAccelDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTestGyroAccelDlg::InitializeGraph()
{
	CRect rcGyro, rcAccel, rcMagnet;
	GetDlgItem(IDC_GRAPH_GYRO)->GetWindowRect(rcGyro);
	GetDlgItem(IDC_GRAPH_ACCEL)->GetWindowRect(rcAccel);
	GetDlgItem(IDC_GRAPH_MAGNET)->GetWindowRect(rcMagnet);
	GetDlgItem(IDC_GRAPH_GYRO)->DestroyWindow();
	GetDlgItem(IDC_GRAPH_ACCEL)->DestroyWindow();
	GetDlgItem(IDC_GRAPH_MAGNET)->DestroyWindow();
	
	ScreenToClient(rcGyro);
	ScreenToClient(rcAccel);
	ScreenToClient(rcMagnet);

	_graphCtrlGyro = new COScopeCtrl(3);		//X,Y,Z
	_graphCtrlGyro->Create(WS_VISIBLE | WS_CHILD, rcGyro, this, IDC_GRAPH_GYRO);
	_graphCtrlGyro->SetRanges(-270., 270.);	//gyro rate range : +-300 deg/sec
	_graphCtrlGyro->autofitYscale = true;
	_graphCtrlGyro->SetYUnits("Value");
	_graphCtrlGyro->SetXUnits("Time");
	_graphCtrlGyro->SetLegendLabel("Gyro(X) deg/sec", 0);
	_graphCtrlGyro->SetLegendLabel("Gyro(Y) deg/sec", 1);
	_graphCtrlGyro->SetLegendLabel("Gyro(Z) deg/sec", 2);
	_graphCtrlGyro->SetPlotColor(RGB(255,0,0), 0);
	_graphCtrlGyro->SetPlotColor(RGB(0,255,0), 1);
	_graphCtrlGyro->SetPlotColor(RGB(0,0,255), 2);
	_graphCtrlGyro->InvalidateCtrl();

	_graphCtrlAccel = new COScopeCtrl(3);		//X,Y,Z
	_graphCtrlAccel->Create(WS_VISIBLE | WS_CHILD, rcAccel, this, IDC_GRAPH_ACCEL);
	_graphCtrlAccel->SetRanges(-3., 3.);	//acceleration range : +- 18g
	_graphCtrlAccel->autofitYscale = true;
	_graphCtrlAccel->SetYUnits("Value");
	_graphCtrlAccel->SetXUnits("Time");
	_graphCtrlAccel->SetLegendLabel("Accel(X)", 0);
	_graphCtrlAccel->SetLegendLabel("Accel(Y)", 1);
	_graphCtrlAccel->SetLegendLabel("Accel(Z)", 2);
	_graphCtrlAccel->SetPlotColor(RGB(255,0,0), 0);
	_graphCtrlAccel->SetPlotColor(RGB(0,255,0), 1);
	_graphCtrlAccel->SetPlotColor(RGB(0,0,255), 2);
	_graphCtrlAccel->InvalidateCtrl();

	_graphCtrlMagnet = new COScopeCtrl(3);		//X,Y,Z
	_graphCtrlMagnet->Create(WS_VISIBLE | WS_CHILD, rcMagnet, this, IDC_GRAPH_MAGNET);
	_graphCtrlMagnet->SetRanges(-0.6, 0.6);	//acceleration range : +- 18g
	_graphCtrlMagnet->autofitYscale = true;
	_graphCtrlMagnet->SetYUnits("Value");
	_graphCtrlMagnet->SetXUnits("Time");
	_graphCtrlMagnet->SetLegendLabel("Magnet(X)", 0);
	_graphCtrlMagnet->SetLegendLabel("Magnet(Y)", 1);
	_graphCtrlMagnet->SetLegendLabel("Magnet(Z)", 2);
	_graphCtrlMagnet->SetPlotColor(RGB(255,0,0), 0);
	_graphCtrlMagnet->SetPlotColor(RGB(0,255,0), 1);
	_graphCtrlMagnet->SetPlotColor(RGB(0,0,255), 2);
	_graphCtrlMagnet->InvalidateCtrl();
}

void CTestGyroAccelDlg::OnDestroy()
{
	CDialog::OnDestroy();

	delete _modelWnd;

	delete _graphCtrlGyro;
	delete _graphCtrlAccel;
	delete _graphCtrlMagnet;
}

void CTestGyroAccelDlg::OnBnClickedRun()
{
	_isRun = !_isRun;

	if(_isRun) {
		QueryPerformanceFrequency (&_freq);
		QueryPerformanceCounter (&_tp);

		InitARS();

		GetDlgItem(IDC_RUN)->SetWindowText("Stop");
		SetTimer(1000, 10, NULL);
	}
	else {
		GetDlgItem(IDC_RUN)->SetWindowText("Start");
		KillTimer(1000);
	}
}

void CTestGyroAccelDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	if(nIDEvent==1000)
	{
		LARGE_INTEGER tc;

		QueryPerformanceCounter (&tc);

		double dt = (double)(tc.QuadPart-_tp.QuadPart)/_freq.QuadPart;

		_tp = tc;

		double gyro[3] = {0., };
		double accl[3] = {0., };
		double magn[3] = {0., };
		double temp[3] = {0., };

		ReadDevice (gyro, accl, magn, temp);

		char buff[256];

		sprintf (buff, "% 8.3f, % 8.3f, % 8.3f", gyro[0], gyro[1], gyro[2]);
		SetDlgItemText (IDC_EDIT1, buff);

		sprintf (buff, "% 8.3f, % 8.3f, % 8.3f", accl[0], accl[1], accl[2]);
		SetDlgItemText (IDC_EDIT2, buff);

		sprintf (buff, "% 8.3f, % 8.3f, % 8.3f", magn[0], magn[1], magn[2]);
		SetDlgItemText (IDC_EDIT3, buff);

		_graphCtrlGyro->AppendPoints(gyro);
		_graphCtrlAccel->AppendPoints(accl);
		_graphCtrlMagnet->AppendPoints(magn);

		_modelWnd->gyroscope	= dVector3(gyro[0]/360., gyro[1]/360., gyro[2]/360.);
		_modelWnd->accelerometer= dVector3(accl[0]/5., accl[1]/5., accl[2]/5.);
		_modelWnd->magnetometer = dVector3(magn[0]/2., magn[1]/2., magn[2]/2.);

		dMatrix R = ARS (gyro, accl, magn, dt);

		sprintf (buff, "% 8.3f, % 8.3f, % 8.3f", average_gyro[0], average_gyro[1], average_gyro[2]);
		SetDlgItemText (IDC_EDIT4, buff);

		sprintf (buff, "% 8.3f, % 8.3f, % 8.3f", _RAD2DEG*adjust_rpy[0], _RAD2DEG*adjust_rpy[1], _RAD2DEG*adjust_rpy[2]);
		SetDlgItemText (IDC_EDIT5, buff);

		_modelWnd->sensorRotation = R;
		_modelWnd->UpdateWnd();
	}

	CDialog::OnTimer(nIDEvent);
}
